#!/usr/local/bin/perl

# -----------------------
# filename:reg_htpasswd.pl
# revised for GTE site Oct 1998
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

use Oraperl;

  $LIVE = "on";

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/pkg_utils.pl';

# ===== HTML setup ======
  &html_header_1("registration reg_htpasswd");
# ===== HTML setup ======

# ============================================================
# $mindypath = 'http://mindy.infomall.org:6399/';   #dv
# $wowpath   = $mindypath.'cgi-bin/wowc/';     #dv
# $morkpath  = 'http://www.carrier.com/';
# $docpath   = $mindypath.'wp/';   #dv
# $textpath  = $docpath.'com_docs/';   #dv
# $adminpath  = '/oradata/disk4/carrier/bwm-admin/';   #dv
# ==============  define cursors =============================
# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  &oracle_login;

  &write_comment("After oracle_login, lda is $lda<BR>");

  $userid = $value[0];

  &write_back_form ($userid);

  &write_res_passwd;

  &write_com_passwd;

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# *******************************************************
# Write back form on final page after passwd file update
# *******************************************************
sub write_back_form
{
   local($cuserid) = @_;

   $backaction = $wowpath.'REG_UPDATE.list_records';
   print "<FORM ACTION=\"$backaction\">\n";
   print "<INPUT TYPE=\"HIDDEN\" NAME=\"userid\" VALUE=\"$cuserid\">\n";
   print "Return to listing: \n";
   print "<INPUT NAME=\"ureg_status\" VALUE=\"P\" SIZE=1 MAXLENGTH=1>\n";
   print "<INPUT TYPE=\"SUBMIT\" VALUE=\"List Records\">\n";
   print "</FORM>\n";
}

# ***************************************************
# Write res ht access and password files and transfer
# ***************************************************
sub write_res_passwd
{
  $AUTHUSERFILE = 'AuthUserFile   /root2/nadocs/private/residential/.htpasswd'; #dv
  $AUTHGROUPFILE = 'AuthGroupFile /root2/nadocs/private/residential/.htgroup';   #dv
  $AUTHNAME = 'AuthName Carrier Residential\nAuthType Basic'; #dv

  &write_comment("<BR> $AUTHUSERFILE<BR>\n");

  $GET_RES_USERS = 
                "SELECT username, user_pw 
                   FROM user_reg
                  WHERE user_permissions LIKE '%H1%'
                  ORDER BY reg_date";

  &write_comment("After defining GET_RES_USERS<BR>");

  $csrpw = &ora_open($lda, $GET_RES_USERS) 
           || print "<BR> error in opening $GET_RES_USERS <BR>\n"; 

  &write_comment("After opening GET_RES_USERS; csrpw is $csrpw <BR>");

  $ii =0;
  while ( ($unm, $pw) = &ora_fetch($csrpw) )
  {
     $uname[$ii] = $unm;
     $passw[$ii] = $pw;
     $ii++;
  }  
  &ora_close($csrpw);
  $usernum = $#uname +1;
  &write_comment("after getting user list of $usernum residential users\n");
  print "<P>Database contains $usernum registered users approved for ";
  print "residential downloads.<BR> \n";

# open new htaccess file 
# ----------------------
   $pwfile = "/root2/nadocs/private/Carrier_s1/regfiles/resuserfile"; #dv
   open (PWFILE, ">$pwfile") || print "Couldn't open $pwfile\n"; 
   select PWFILE;
   print "$AUTHUSERFILE\n";
   print "$AUTHGROUPFILE\n";
   print "$AUTHNAME\n";
   print "<Limit GET POST>\n";
   print "require group res_user\n";

   print "</Limit>\n";
   close (PWFILE);
  
# print STDOUT "<BR>after writing access file<BR>\n"; 
  select STDOUT;

# open new htgroup file 
# ----------------------
   $pgfile = "/root2/nadocs/private/Carrier_s1/regfiles/resgroupfile"; #dv
   open (PGFILE, ">$pgfile") || 
           print "Couldn't open $pgfile for writing\n"; 

   for ($i =0; $i <= $#uname; $i++)
   {
      print PGFILE "res_user: $uname[$i]\n";
   }  
   close (PGFILE);
       

# open new password file 
# ----------------------
  $ppwfile="/root2/nadocs/private/Carrier_s1/regfiles/respassfile";  #dv
  open(HTPASS, ">$ppwfile");
  for ($i = 0; $i <= $#uname; $i++) {
     $pass = crypt("$passw[$i]","jc");
     print(HTPASS "$uname[$i]:$pass\n");
  }
  close(HTPASS);

  print "<P>New access, password and group files written for Comfort at Home downloads<BR>\n";

  if ($LIVE eq "on") 
  {
 #  system("/bin/cp $pwfile  /root2/nadocs/private/residential/.htaccess");  #dv
    system("/bin/cp $resl1dir/.htpasswd $resl1dir/htpasswd.bak");
    system("/bin/cp $resl1dir/.htgroup $resl1dir/htgroup.bak");
    system("/bin/cp $ppwfile /root2/nadocs/private/residential/.htpasswd");  #dv
    system("/bin/cp $pgfile  /root2/nadocs/private/residential/.htgroup");  #dv
    print "New password and group files copied to the restricted access Comfort at Home directory.<P>\n";
  }
}
# ***************************************************
# Write com ht access and password files and transfer
# ***************************************************
sub write_com_passwd
{
  $AUTHUSERFILE = 'AuthUserFile /root2/nadocs/private/commercial/.htpasswd'; #dv
  $AUTHGROUPFILE = 'AuthGroupFile /root2/nadocs/private/commercial/.htgroup';   #dv
  $AUTHNAME = 'AuthName Carrier Commercial\nAuthType Basic'; #dv

  &write_comment("<BR> $AUTHUSERFILE<BR>\n");

  $GET_COM_USERS = 
                "SELECT username, user_pw 
                   FROM user_reg
                  WHERE user_permissions LIKE '%W1%'
                  ORDER BY reg_date";

  $csrpwc = &ora_open($lda, $GET_COM_USERS) 
           || print "<BR> error in opening $GET_COM_USERS <BR>\n"; 

  $ii =0;
  while ( ($unm, $pw) = &ora_fetch($csrpwc) )
  {
     $unamec[$ii] = $unm;
     $passwc[$ii] = $pw;
     $ii++;
  }  
  &ora_close($csrpwc);
  
  $usernum = $#unamec +1;
  &write_comment("after getting user list of $usernum commercial users\n");
  print "<P>Database contains $usernum registered users approved for ";
  print "commercial downloads. <BR>\n";

# open new htaccess file 
# ----------------------
   $pwcfile = "/root2/nadocs/private/Carrier_s1/regfiles/comuserfile"; #dv
   open (PWFILE, ">$pwcfile") || warn "Couldn't open userfile\n"; 
   select PWFILE;
   print "$AUTHUSERFILE\n";
   print "$AUTHGROUPFILE\n";
   print "$AUTHNAME\n";
   print "<Limit GET POST>\n";
   print "require group com_user\n";

   print "</Limit>\n";
   close (PWFILE);
  
# print STDOUT "<BR>after writing access file<BR>\n"; 
  select STDOUT;

# open new htgroup file 
# ----------------------
   $pgcfile = "/root2/nadocs/private/Carrier_s1/regfiles/comgroupfile"; #dv
   open (PGFILE, ">$pgcfile") || warn "Couldn't open groupfile for writing\n"; 

   for ($i =0; $i <= $#unamec; $i++)
   {
      print PGFILE "com_user: $unamec[$i]\n";
   }  
   close (PGFILE);
       

# open new password file 
# ----------------------
  $ppwcfile="/root2/nadocs/private/Carrier_s1/regfiles/compassfile";  #dv
  open(HTPASS, ">$ppwcfile");
  for ($i = 0; $i <= $#unamec; $i++) {
     $pass = crypt("$passwc[$i]","cm");
     print(HTPASS "$unamec[$i]:$pass\n");
  }
  close(HTPASS);

  print "<P>New access, password and group files written for Comfort at Work downloads.<BR>\n";

  if ($LIVE eq "on") 
  {
    print "set to copy to live files, LIVE is $LIVE<BR>\n";
 #  system("/bin/cp $pwcfile  /root2/nadocs/private/commercial/.htaccess");  #dv
    system("/bin/cp $coml1dir/.htpasswd $coml1dir/htpasswd.bak");
    system("/bin/cp $coml1dir/.htgroup $coml1dir/htgroup.bak");
    system("/bin/cp $ppwcfile /root2/nadocs/private/commercial/.htpasswd");  #dv
    system("/bin/cp $pgcfile  /root2/nadocs/private/commercial/.htgroup");  #dv
  print "New password and group files copied to the restricted access Comfort at Work directory.<P>\n";
  }
  elsif ($LIVE eq "off")
  {
    print "<P>set NOT to copy to live files, LIVE is $LIVE<BR>\n";
  }

}
