#!/usr/local/bin/perl

# -----------------------
# filename:
# write_download_list_rc_small.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# revised to perl5 9/98 
# written august 1996
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

# ===== HTML setup ======
  &html_header_1("List of Carrier Downloads for Model and Download Type");
# ===== HTML setup ======

# ====oraperl setup =====
  &oracle_login;
# ====oraperl setup =====

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ============================================================
# =================== body of program ========================

  &get_query;

  $dlModel  = $value[0];
  $dltype  = $value[1];

  &write_comment( "<P>download type is $dltype ");

  &print_cs_download_seguepage($dlModel, $dltype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
#           log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)	|| die $ora_errstr;
# ============================================================

# =============== start of subroutines =======================
# ******************************************************
# Prints Download Segue Page for Comm level 1 documents
# ******************************************************
sub print_cs_download_seguepage
{
   local ($dlModel, $dltype) = @_;

   $csrdoc = &ora_open ($lda, $GET_HEADER_DOC) 
                   || print "failed to open cursor $GET_HEADER_DOC<BR>\n";
   $csrtxt = &ora_open ($lda, $GET_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";
   $csrtdesc = &ora_open ($lda, $GET_TYPE_DESCRIPTION) 
                   || print "failed to open cursor $GET_TYPE_DESCRIPTION<BR>\n";
   $csrlinks = &ora_open ($lda, $GET_ELEC_LIT_LINKS) 
                   || print "failed to open cursor $GET_ELEC_LIT_LINKS<BR>\n";

   &write_comment("after opening cursors csrdoc, csrtxt, csrtdesc, csrlinks");

   &ora_bind ($csrlinks, $dlModel, $dltype);

   while ( ($dlftype, $fname, $ext, $desc, $format, $sizekb, $ok, 
             $desc_id, $lic_id, $inst_id, $dlmodel_name) 
          = &ora_fetch($csrlinks) )
   {

      &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");

      &write_comment("filename $fname.$ext, ok is $ok, dlmodel_name is $dlmodel_name");

      if  ($ok =1 )
      {
         if ($fname ne '') 
         {
            &ora_bind($csrtdesc, $dlftype);
            while ( ($typedesc) = &ora_fetch($csrtdesc) )
            {  $typeheader = $typedesc; 
               if ($desc ne '') {$typeheader = $desc; }
            }

            $htfname = $fname.'.'.$ext;
            &write_comment("Full htfilename is $htfname\n");

            $lid = $lic_id;
            $licnum = 0;
            &ora_bind($csrtxt, $lid);
            while ( ($lic_filename, $lic_ext) = &ora_fetch($csrtxt) )
            {
               $lic_filename =~ s/ /_/g;
               $lic_filename =~ s/-/_/g;
               $licnum = $licnum +1;
               &write_comment("license filename is $lic_filename; extension is $lic_ext\n");
            }

            if ($licnum > 0)
            {
               $htmodel = $modelno; $htmodel =~ s/ /+/g;  $htmodel =~ s/-/%2D/g;
               $htdlmdl = $dlmodel_name; $htdlmdl =~ s/ /+/g;  $htdlmdl =~ s/-/%2D/g;
 $licstring = '/write_download_license_rc.sh?licid='.$lic_id.'&dlmdl='.$htdlmdl;
 $licstring = $licstring.'&instid='.$inst_id.'&dltype='.$dltype;
               &write_comment("license string is $licstring\n");
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$plpath$licstring\">$typeheader</A></B><P>\n";
            }
            else
            {
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$dldirectory$fname.$ext\">$typeheader</A></B><P>\n";
           &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");
            }

            &ora_bind($csrtxt, $inst_id);
            ($inst_filename, $inst_ext) = &ora_fetch($csrtxt);
               $inst_filename =~ s/ /_/g;
               $inst_filename =~ s/-/_/g;
               &write_comment("install filename is $inst_filename; extension is $inst_ext\n");

          
            if ($dltype ne 'E20-II')
            {
               print "<UL>\n";
               &ora_bind($csrtxt, $desc_id);
               while ( ($desc_filename, $desc_ext) = &ora_fetch($csrtxt) )
               {
                  $desc_filename =~ s/ /_/g;
                  $desc_filename =~ s/-/_/g;
                  &write_comment("description filename is $desc_filename; textid is $desc_id\n");
                  $descdocname = $desc_filename.'.html';
                  
                  open (DESCFILE, "$textpath$descdocname") ||
                               print "failed to open $textpath$descdocname\n";
                  
                  while (<DESCFILE>)
                  {
                      chop;
                      print "$_\n";
                  }
               }
               print "</UL>\n";
            }
         }
      }
   }
   &ora_close($csrlinks);
   &ora_close($csrdoc);
}
