#!/usr/local/bin/oraperl

# -----------------------
# filename:
# 
# written august 1996
# author Barbara Mihalas
# -----------------------

require '/oradata/disk4/carrier/cdata/cgi-bin/pl/user_specs.pl';
require '/oradata/disk4/carrier/cdata/cgi-bin/pl/user_paths.pl';

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

# ==========================================================
# ================= oraperl setup ==========================

$ENV{'ORACLE_HOME'}= "/usr/oracle";
$ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
$ENV{'WOW_UID'}= "$user/$user";
$ENV{'ORACLE_SID'}= "mindy";
## print "query string is $ENV{'QUERY_STRING'}<BR>\n";
## print "oracle_home is $ENV{'ORACLE_HOME'}<BR>\n";
## print "PATH is $ENV{'PATH'}<BR>\n";

# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit"
	if 0;

# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;

# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;

# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');

# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', $user, $user)	|| die $ora_errstr;

# ==============  end of oraperl setup =======================
# ============================================================

  $textpath  = '/oradata/disk4/httpd80/htdocs/wp/com_docs_pub/';
  $morkpdfpath = 'http://mork.infomall.org/';
  $dldirectory = $morkpdfpath.'private/commercial/downloads_l1/';

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ==============  define cursors =============================
  $GET_HEADER_DOC =
                 "SELECT filename, extension
                    FROM text_objects 
                   WHERE textid = :1";
 
# Elec lit (474); Elec catalog (51); CAD templates (64); Eng software(37)

# ==============  end of cursors =============================


# ============================================================
# =================== body of program ========================

  $query_string = $ENV{'QUERY_STRING'};

# Read input buffer
# read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );

# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";

# Parse input buffer
# &parse;
# ---------------------
  &parse($query_string);

  $dlModel  = $value[0];
  $dltype  = $value[1];

  &write_comment( "<P>download type is $dltype ");

  &print_cs_download_seguepage($dlModel, $dltype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================

# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;

# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($instring) = @_;
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $instring);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
   #   print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

# ******************************************************
# Prints Download Segue Page for Comm level 1 documents
# ******************************************************
sub print_cs_download_seguepage
{
   local ($dlModel, $dltype) = @_;
&write_comment("dltype is: $dltype");
   $GET_ELEC_LIT_LINKS  =
              "SELECT downloadfiletype, filename, extension, description,
                      fileformat, disksize, downloadable, descriptionid,
                      licenseid, installid, downloadmodel 
                 FROM download_objects
                WHERE upper(DownloadModel) = :1
                  AND TO_NUMBER(downloadable) = 1
                  AND obsolete IS NULL
                ORDER BY description, downloadmodel";

   $GET_TEXT_FILENAME =
              "SELECT filename, extension 
                 FROM text_objects
                WHERE textid = :1";

   $GET_TYPE_DESCRIPTION =
              "SELECT description 
                 FROM download_object_types
                WHERE downloadfiletype = :1";

   $csrdoc = &ora_open ($lda, $GET_HEADER_DOC) 
                   || print "failed to open cursor $GET_HEADER_DOC<BR>\n";
   $csrtxt = &ora_open ($lda, $GET_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";
   $csrtdesc = &ora_open ($lda, $GET_TYPE_DESCRIPTION) 
                   || print "failed to open cursor $GET_TYPE_DESCRIPTION<BR>\n";
   $csrlinks = &ora_open ($lda, $GET_ELEC_LIT_LINKS) 
                   || print "failed to open cursor $GET_ELEC_LIT_LINKS<BR>\n";

#  $textpath  = '/oradata/disk4/carrier/wpdv/com_docs/';   #dv

   &ora_bind ($csrlinks, $dlModel );


#  $dldirectory = 'abd';
   while ( ($dlftype, $fname, $ext, $desc, $format, $sizekb, $ok, 
             $desc_id, $lic_id, $inst_id, $dlmodel_name) 
          = &ora_fetch($csrlinks) )
   {
      &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");
      &write_comment("filename $fname.$ext, ok is $ok, dlmodel_name is $dlmodel_name");
      if  ($ok =1 )
      {
         if ($fname ne '') 
         {
            &ora_bind($csrtdesc, $dlftype);
            while ( ($typedesc) = &ora_fetch($csrtdesc) )
            {  $typeheader = $typedesc; 
               if ($desc ne '') {$typeheader = $desc; }
            }

            $htfname = $fname.'.'.$ext;
            &write_comment("Full htfilename is $htfname\n");

            $lid = $lic_id;
            $licnum = 0;
            &ora_bind($csrtxt, $lid);
            while ( ($lic_filename, $lic_ext) = &ora_fetch($csrtxt) )
            {
               $lic_filename =~ s/ /_/g;
               $lic_filename =~ s/-/_/g;
               $licnum = $licnum +1;
               &write_comment("license filename is $lic_filename; extension is $lic_ext\n");
            }

            if ($licnum > 0)
            {
               $htmodel = $modelno; $htmodel =~ s/ /+/g;  $htmodel =~ s/-/%2D/g;
               $htdlmdl = $dlmodel_name; $htdlmdl =~ s/ /+/g;  $htdlmdl =~ s/-/%2D/g;
 $licstring = 'write_download_license_rc.sh?licid='.$lic_id.'&dlmdl='.$htdlmdl;
 $licstring = $licstring.'&instid='.$inst_id.'&dltype='.$dltype;
               &write_comment("license string is $licstring\n");
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$plpath$licstring\">$typeheader</A></B><P>\n";
            }
            else
            {
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$dldirectory$fname.$ext\">$typeheader</A></B><P>\n";
                 # filesize = $sizekb KB<P>\n";
           &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");
            }

            &ora_bind($csrtxt, $inst_id);
            ($inst_filename, $inst_ext) = &ora_fetch($csrtxt);
               $inst_filename =~ s/ /_/g;
               $inst_filename =~ s/-/_/g;
               &write_comment("install filename is $inst_filename; extension is $inst_ext\n");

          
            if ($dltype ne 'E20-II')
            {
               print "<UL>\n";
               &ora_bind($csrtxt, $desc_id);
               while ( ($desc_filename, $desc_ext) = &ora_fetch($csrtxt) )
               {
                  $desc_filename =~ s/ /_/g;
                  $desc_filename =~ s/-/_/g;
                  &write_comment("description filename is $desc_filename; extension is $desc_ext\n");
                  $descdocname = $desc_filename.'.html';
                  
                  open (DESCFILE, "$textpath$descdocname") ||
                               print "failed to open $textpath$descdocname\n";
                  
                  while (<DESCFILE>)
                  {
                      chop;
                      print "$_\n";
                  }
               }
               print "</UL>\n";
            }
         }
      }
   }
   &ora_close($csrlinks);
   &ora_close($csrdoc);
}

# ******************************************
# writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";

}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Placeholder for document title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}
