#!/usr/local/bin/perl
#  
# -----------------------
# filename:
# write_download_list_rc.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

# ===== HTML setup ======
  &html_header_1("List downloads for specified download type");
# ===== HTML setup ======
# 
# ====oraperl setup =====
  &oracle_login;
# ====oraperl setup =====

  &write_comment("path for pdf hrefs is $dldirectory\n");

# =================== body of program ========================

  &get_query;

  $dltype  = $value[0];
  &write_comment( "<P>download type is $dltype ");

  &print_cs_download_seguepage($dltype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
#          log out of the database (this is ESSENTIAL!)
   do ora_logoff($lda)				
                 || die $ora_errstr;
# ============================================================

# =============== start of subroutines =======================
# ******************************************************
# Prints Download Segue Page for Comm level 1 documents
# ******************************************************
sub print_cs_download_seguepage
{
  local ($dltypein) = @_;

  $csrdoc = &ora_open ($lda, $GET_HEADER_DOC) 
           || print "failed to open cursor $GET_HEADER_DOC<BR>\n";

  $csrtxt = &ora_open ($lda, $GET_DL_TEXT_FILENAME) 
           || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";

  $csrtdesc = &ora_open ($lda, $GET_TYPE_DESCRIPTION) 
           || print "failed to open cursor $GET_TYPE_DESCRIPTION<BR>\n";

  $csrlinks = &ora_open ($lda, $GET_ELEC_LIT_LINKS) 
           || print "failed to open cursor $GET_ELEC_LIT_LINKS<BR>\n";

  if ($dltypein eq 'eleclit'  ) 
  { 
     &ora_bind ($csrdoc, '474'); 
     ($docname) = &ora_fetch($csrdoc); 
     $docname   =~ s/-/_/g;
     $docname   =~ s/\s/_/g;
     &ora_bind ($csrlinks, 'PDF', '%%');
  }
  if ($dltypein eq 'eleccat'  ) 
  { 
     &ora_bind ($csrdoc, '51');  
     ($docname) = &ora_fetch($csrdoc); 
     $docname   =~ s/-/_/g;
     $docname   =~ s/\s/_/g;
     &ora_bind ($csrlinks, '%%', 'E-CAT');
  }
  if ($dltypein eq 'template' ) 
  { 
     &ora_bind ($csrdoc, '64');  
     ($docname) = &ora_fetch($csrdoc); 
     $docname   =~ s/-/_/g;
     $docname   =~ s/\s/_/g;
     &ora_bind ($csrlinks, '%%', 'CAD%TEMPLATE');
  }  
  if ($dltypein eq 'E20-II' )   
  { 
     &ora_bind ($csrdoc, '37');  
     ($docname) = &ora_fetch($csrdoc); 
     $docname   =~ s/-/_/g;
     $docname   =~ s/\s/_/g;
     &ora_bind ($csrlinks, '%%', 'E20-II');
  } 
  if ($dltypein eq 'engdesc' )   
  {
     $docname = 'nao_sw1/nao_swd1.html'; 
  }

  $unixfilename = $docname.'.html';
  $unixfile = $textpath.$unixfilename;

# &write_comment("unix filename is $unixfilename<BR>\n");

  open (SEGUEDOC, $unixfile) 
               || print "failed to open $unixfilename<BR>\n";

  while (<SEGUEDOC>)
  {
     chop;
     print "$_\n";
  } 
  close SEGUEDOC;

  print "<P><P>\n";

  while ( ($dlftype, $fname, $ext, $desc, $format, $sizekb, $ok, 
       $desc_id, $lic_id, $inst_id, $dlmodel) 
       = &ora_fetch($csrlinks) )
  {
     &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");

     if  ($dltypein eq 'template') 
     {
        $desc =~ s/Electronic Templates - //;
     }
     if  ($ok =1 )
     {
        &write_comment("file is downloadable");
        if ($fname ne '') 
        {
           &ora_bind($csrtdesc, $dlftype);
           while ( ($typedesc) = &ora_fetch($csrtdesc) )
           {  $typeheader = $typedesc; 
              if ($desc ne '') {$typeheader = $desc; }
           }

           $htfname = $fname.'.'.$ext;
           &write_comment("dl filename is $htfname; license id is $lic_id");

           $lid = $lic_id;
           $licnum = 0;
           $bindstatus = &ora_bind($csrtxt, $lid);
           while ( ($lic_filename, $lic_ext) = &ora_fetch($csrtxt) )
           {
              $lic_filename =~ s/ /_/g;
              $lic_filename =~ s/-/_/g;
              $licnum = $licnum +1;
              &write_comment("license filename is $lic_filename; extension is $lic_ext\n");
           }

           if ($licnum > 0)
           {
              $htmodel = $modelno; $htmodel =~ s/ /+/g;  $htmodel =~ s/-/%2D/g;
              $htdlmdl = $dlmodel; $htdlmdl =~ s/ /+/g;  $htdlmdl =~ s/-/%2D/g;
              $licstring = '/write_download_license_rc.sh?licid='.$lic_id.'&dlmdl='.$htdlmdl;
              $licstring = $licstring.'&instid='.$inst_id.'&dltype='.$dltypein;
              &write_comment("license string is $licstring\n");
              if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
              print "<FONT SIZE=3 FACE=\"Times New Roman\">\n";
              print "<B><A HREF=\"$plpath$licstring\">$typeheader</A></B><P>\n";
              print "</FONT>\n";
           }
           else
           {
              if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
              print "<B><A HREF=\"$dldirectory$fname.$ext\">$typeheader</A></B><P>\n";
           }

           &ora_bind($csrtxt, $inst_id);
           ($inst_filename, $inst_ext) = &ora_fetch($csrtxt);
           $inst_filename =~ s/ /_/g;
           $inst_filename =~ s/-/_/g;

           if ($dltypein ne 'E20-II')
           {
              print "<UL>\n";
              &ora_bind($csrtxt, $desc_id);
              while ( ($desc_filename, $desc_ext) = &ora_fetch($csrtxt) )
              {
                 $desc_filename =~ s/ /_/g;
                 $desc_filename =~ s/-/_/g;
                 &write_comment("description filename is $desc_filename; extension is $desc_ext\n");
                 $descdocname = $desc_filename.'.html';
                 open (DESCFILE, "$textpath$descdocname") ||
                 print "failed to open $textpath$descdocname\n";

                 while (<DESCFILE>)
                 {
                    chop;
                    print "$_\n";
                 }
              }
              print "</UL>\n";
           }
        }
     }
  }
  &ora_close($csrlinks);
  &ora_close($csrdoc);
}

