#!/usr/local/bin/oraperl

# -----------------------
# filename: util.pl
# written June 1997
# author Barbara Mihalas
# -----------------------

# ******************************************
# ******************************************
sub parse {
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $buffer);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       $x = $name[$i];
       $fields{$x} = $value[$i];
       print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Placeholder for document title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";
}

# **********************************************
# This Procedure writes the HTML header w/ Title
# **********************************************
sub html_header_title 
{
 local ($title) = @_;
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>$title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}
