#!/bbn/bin/perl

# -----------------------
# filename:
# write_download_license_rc.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("License Page for Carrier Software Download via Resource Center");
# ===== HTML setup ======

# ====oraperl setup =====
  &oracle_login;
# ====oraperl setup =====

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ============================================================
# =================== body of program ========================

  &get_query;

# $query_string = $ENV{'QUERY_STRING'};
# Read input buffer
# read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";
# Parse input buffer
# &parse;
# ---------------------
# &parse($query_string);

  $licid   = $value[0];
  $dlmdl   = $value[1];
  $instid  = $value[2];
  $dltype  = $value[3];

#====for testing=====
# $licid   = 52;
# $dlmdl   = '42S213';
# $instid  = 723;
# $dltype  = 'eleccat';

# print "<P>Input model is $modelno for download type $dltype<BR>\n";
  &write_comment("licid=$licid; dlmdl=$dlmdl; instid=$instid; dltype=$dltype");

  &print_licensepage($licid, $dlmdl, $instid, $dltype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
#         log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ============================================================

# =============== start of subroutines =======================

# ******************************************************
# Prints Download Segue Page for Comm level 1 documents
# ******************************************************
sub print_licensepage
{
   local ($licenseid, $dlmodel, $installid, $dltypein) = @_;

   $csrdoc = &ora_open ($lda, $GET_HEADER_DOC) 
                   || print "failed to open cursor $GET_HEADER_DOC<BR>\n";
   $csrtxt = &ora_open ($lda, $GET_DL_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_DL_TEXT_FILENAME<BR>\n";
   $csrinfo = &ora_open ($lda, $GET_ELEC_LIT_RC) 
                   || print "failed to open cursor $GET_ELEC_LIT_RC<BR>\n";

   print "<A NAME=\"top\"></A>\n";
   print "<A HREF=\"#response\">down to accept/decline</A><P>\n";

   $licnum = 0;
   $bindstatus = &ora_bind($csrtxt, $licenseid);
   while ( ($lic_filename, $lic_ext) = &ora_fetch($csrtxt) )
   {
      $lic_filename =~ s/ /_/g;
      $lic_filename =~ s/-/_/g;
      $licnum = $licnum +1;
      &write_comment("license filename is $lic_filename; extension is $lic_ext\n");
      $licfile = $textpath.$lic_filename.'.html';
      open (LICENSE, "$licfile") || print "failed to open $licfile.\n";
      while (<LICENSE>)
      {
         chop;
         print "$_\n";
      }
   }

   print "<P>\n";

   &ora_bind($csrtxt, $installid);
   while ( ($inst_filename, $inst_ext) = &ora_fetch($csrtxt) )
   {
      $inst_filename =~ s/ /_/g;
      $inst_filename =~ s/-/_/g;
      &write_comment("install filename is $inst_filename; extension is $inst_ext\n");
   }

   &ora_bind($csrinfo, $dlmodel);
   while ( ($dltype, $dlfilename, $dlfext) = &ora_fetch($csrinfo) )
   {
      $dlfilename =~ s/ /_/g;
      $dlfilename =~ s/-/_/g;
      $dnldfilename = join('.', $dlfilename, $dlfext);
#     $dnldfilename = "/$dnldfilename"; 
      &write_comment("download filename is $dnldfilename; extension is $dlfext");
      $dnldtype = $dltype;
   }
   &write_comment("download filename is $dnldfilename; extension is $dlfext");
   
 
   print "<P><HR><P>\n";
   print "<A NAME=\"response\"></A>\n";

   $backscript = '/write_download_list_rc.sh';
   print "<FORM TARGET=\"bodyText\" ACTION=\"$plpath$backscript\" >\n";
   print "<INPUT TYPE=\"HIDDEN\" NAME=\"dtype\" VALUE=$dltypein>\n";
   print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Decline\">\n";
   print "</FORM>\n";
   print "<NOBR>\n";

   if ($installid ne '')
   {
      $installscript = '/write_download_install_rc.sh';
      print "<FORM TARGET=\"bodyText\" ACTION=\"$plpath$installscript\" >\n";
      print "<INPUT TYPE=\"HIDDEN\" NAME=\"instid\" VALUE=$installid>\n";
      print "<INPUT TYPE=\"HIDDEN\" NAME=\"dlmodel\" VALUE=$dlmodel>\n";
      print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Accept: Download Install Instructions\">\n";
      print "</FORM>\n";
      print "<NOBR>\n";
   }
   
   &write_comment(" download filename is $dnldfilename in directory $dldirectory");
   $dlfile = $dldirectory.$dnldfilename;
   print "<A  HREF=\"$dlfile\" >Accept; Download File</A>\n";
   print "</NOBR><P>\n";
  

   print "<A HREF=\"#top\"><I>(top of page)</I></A>\n";
   
   &ora_close($csrtxt);
   &ora_close($csrdoc);
   &ora_close($csrinfo);
}
