#!/usr/local/bin/perl

# -----------------------
# filename:
# write_com_fieldpage_cs.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# updates august 1998
# updates 1997
# written august 1996
# author Barbara Mihalas
# -----------------------
$DEBUG = 0;

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("product data page reached from Carrier Search");
# ===== HTML setup ======

  print "<!-- 8/98 revision --><BR>\n";
  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $unittype = $value[1];

  print "<!-- modelno = $modelno; unittype = $unittype -->\n";

  &write_modelpage ($modelno, $unittype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin, $unittype) = @_;

   print "<A NAME=\"pagetop\"></A>\n";
   print "<P><BR>\n";

   print "<A HREF=\"$oraclepath/CSEARCH.list_all_models1\"><I>back to model search</I></A>\n";
   print "<P>\n";

#===========
 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   $modeluc = $modelin; 
   $modeluc =~ tr/a-z/A-Z/;
   &ora_bind ($csrtab, $modeluc);

   ($tablename, $modelalias) = &ora_fetch($csrtab);
   if ($DEBUG > 0) {
      &write_comment(" input model is $modeluc, alias is $modelalias");
   }

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }

   if ($modelalias ne '') { $modelprt = $modelalias; }
   else { $modelprt = $modelin; }

   &ora_close($csrtab);

   &write_comment(" input model is $modelin, alias is $modelalias\n");

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   &display_graphic($modeluc);

   print "<P><P>\n";

   &display_productpage_text($modeluc);

   &write_default_table ($modelin, $unit_type); 

   &frameD_topofpage;
}
# ******************************************
# ******************************************
