#!/usr/local/bin/perl54

# -----------------------
# filename:
# write_commdl_fieldpage.pl
# written oct 1997
# author Barbara Mihalas
# -----------------------

$DEBUG=0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/product_queries.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  end of cursors =============================

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

  print "<!-- 9/98 revision --><BR>\n";
  print "<!-- 11/8/97 revision --><BR>\n";

  &write_comment("End of HTML setup; 9/98 revision");

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $unittype = $value[1];

  &write_comment("model is $modelno ");

  &write_modelpage ($modelno, $unittype);

# ==================end  body of program =====================
# ============================================================
# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin, $unittype) = @_;

#  print "<A NAME=\"pagetop\"></A>\n";
   &caw_frameD_back_header;
   print "<P>\n";
   &back_to_caw_model_search;
   print "<BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   $modeluc = $modelin; 
   $modeluc =~ tr/a-z/A-Z/;
   &ora_bind ($csrtab, $modeluc);

#========
   ($tablename, $modelalias) = &ora_fetch($csrtab);
   if ($DEBUG > 0) {
      &write_comment(" input model is $modeluc, alias is $modelalias");
   }

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }

   if ($modelalias ne '') { $modelprt = $modelalias; }
   else { $modelprt = $modelin; }

   &ora_close($csrtab);

   &write_comment(" input model is $modelin, alias is $modelalias\n");

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   &display_graphic($modeluc);

   print "<P><P>\n";

   &display_productpage_text($modeluc);

#  &write_dframe_download_links ($modelin);  # in pkg_utils.pl

   &write_default_table ($modelin, $unit_type); 

#========
   &frameD_topofpage;
}

